CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  FibVal = 28

OBJ
  Fib : "FibTest"
  Debug : "FullDuplexSerial"

PUB Main | c,s,e

  Debug.Start(31, 30, 0, 115200)
  Fib.Start(0,0)
  repeat                                            
    c := Debug.Rx
    Debug.Str(string("JDForth Fibonacci Test",13,10,"Fib("))
    Debug.Dec(FibVal)
    Debug.Str(string(")",13,10,"Spin "))
    s := CNT
    c := SpinFibo(FibVal)
    e := CNT
    ShowResult(e-s, c)
    Debug.Str(string("Pure Forth "))
    Fib.Fib1(FibVal)
    ShowResult(Fib.Pop, Fib.Pop)
    Debug.Str(string("Forth + CORE: "))
    Fib.Fib2(FibVal)
    ShowResult(Fib.Pop, Fib.Pop)
    Debug.Str(string("Pure CORE: "))
    Fib.Fib3(FibVal)
    ShowResult(Fib.Pop, Fib.Pop)

PRI SpinFibo(n) : val
  if n =< 1
    val := n
  else
    val := SpinFibo(n-1) + SpinFibo(n-2)

PRI ShowResult(time, fibo)
  Debug.Dec(fibo)
  Debug.Tx(32)
  Debug.Dec((time >> 4) / 5_000)
  Debug.Str(string(" milliseconds",13,10))


{
  Fib.Start(0,0)
  s := CNT
  c1 := SpinFibo(FibVal)
  e := CNT
  c1 := e - s
  Fib.Fib1(FibVal)
  c2 := Fib.Pop
  s := Fib.Pop
  Fib.Fib2(FibVal)
  c3 := Fib.Pop
  e := Fib.Pop
  Fib.Fib3(FibVal)
  c4 := Fib.Pop
  f := Fib.Pop
  repeat
}

          